
---
### Linux 설치

#### 파이썬 설치
```
$ # sudo apt install python3
	v 3.6.9 , python-py36
```
* 우분투 18.04는 python3가 기본 내장되어 있으므로 실행할 필요 없음

#### cmake 빌드스크립트 작성기 설치
```
$ sudo apt install cmake
```

#### make 빌드스크립트 실행기 설치
```
$ sudo apt install make
```

#### xalan xsl 컴파일러 설치
```
$ sudo apt install xalan
	v 1.11
```

#### gcc c/c++ 컴파일러
```
$ sudo apt install gcc
```

#### g++ c++ 컴파일러
```
$ sudo apt install g++
```

#### boost python 사용을 위한 boost c++라이브러리
```
$ sudo apt install libboost-all-dev
	v 1.65.0(우분투 18.04 최신 지원)
```

#### makepnc 설치
```
$ sudo makepnc_install
```

#### makepnc 테스트
```
$ makepnc sample_proxy.xml ./sample_proxy
```


---



### Windows 설치

#### 파이썬 설치
https://www.python.org/ > Download > Windows > Windows x86-64 executable installer
https://www.python.org/ftp/python/3.8.5/python-3.8.5-amd64.exe
* 반드시 executable installer 로 설치하여야 C를 위한 파이썬 include 디렉토리 및 라이브러리가 설치됩니다.
* embeddable zip 에는 C를 위한 파이썬 include 디렉토리 및 라이브러리가 없기 때문에 makepnc가 동작하지 않습니다.
* web-based installer 는 C를 위한 파이썬 include 디렉토리 및 라이브러리의 설치 여부가 확인되지 않았습니다.
* 사용하기 원하는 버전을 선택하면 됩니다.
* 설치시 다음이 PATH에 설정되어야 합니다.
 * `C:\Program Files\Python38\Scripts\`
 * `C:\Program Files\Python38\`
 * `C:\Program Files\Python38\DLLs`

#### git-scm 설치
https://git-scm.com/download/win
* windows 환경이지만 makepnc는 bash 스크립트로 작성되어 있기 때문에 bash쉘이 필요합니다.
* makepnc, xalan, xerces 를 안정적으로 설치하기 위해 msys 기반의 git-bash를 활용합니다.
* install 이나 portable 중 선호에 따라 사용하면 됩니다.

#### Visual Studio 설치
https://visualstudio.microsoft.com/ko/thank-you-downloading-visual-studio/?sku=Community&rel=16
* Visual Studio 설치시 "C++을 사용한 데스크톱 개발" 이 반드시 필요합니다.
* makepnc는 Visual Studio에 포함된 cmake를 활용합니다.
* makepnc는 Visual Studio에 포함된 nmake/cl/link를 활용합니다.

#### xalan xsl 컴파일러 설치
http://archive.apache.org/dist/xerces/c/3/binaries/xerces-c-3.1.1-x86_64-windows-vc-10.0.zip
http://archive.apache.org/dist/xalan/xalan-c/binaries/xalan_c-1.11-amd64-windows-VC100.zip
* 압축을 해제하여 git-scm을 설치한 디렉토리내의 mingw64 디렉토리에 복사하여 설치합니다.

#### boost python 사용을 위한 boost c++라이브러리
* https://www.boost.org/users/download/ 에서 boost라이브러리를 다운받고 빌드합니다. 빌드과정은 인터넷 검색하면 상세한 설명을 찾을수 있습니다.
* 사전 빌드된 설치파일을 https://sourceforge.net/projects/boost/files/boost-binaries/ 에서 다운받을수도 있습니다. (추천)
  * python을 64비트 사용시 boost 라이브러리도 64비트로 빌드된 것이어야 합니다.
* 추천 다운로드 : https://sourceforge.net/projects/boost/files/boost-binaries/1.72.0/boost_1_72_0-msvc-14.2-64.exe/download
* makepnc 설치시 사전 빌드된 라이브러리를 사용하는것이 편리합니다.

#### Nerv 미들웨어 설치
https://test.waregram.com/attachments/download/1339/Nerv64_Object_Framework_2_3_4_6_Install_20190412.msi
* 미들웨어를 설치합니다.

#### makepnc_install_디렉토리/xsl/py_nerv/build/CMakeList.xsl 수정
```
29:            SET(Boost_INCLUDE_DIRS "E:/Devtools/boost_1_72_0_msvc142_64")
30:            SET(Boost_LIBRARY_DIRS "E:/Devtools/boost_1_72_0_msvc142_64/lib64-msvc-14.2")
```
* 29~30: 설치한 boost 의 경로로 수정합니다.

#### makepnc 설치
````
$ makepncw_install
````
* 주의 makepnc_install은 리눅스용이므로 makepncw_install로 설치해야 합니다.

#### makepnc 테스트
```
$ makepnc sample_proxy.xml ./sample_proxy
```

